from asdl import pybase

option_t = int  # type alias for integer

class option_i(object):
  errexit = 1
  nounset = 2
  hashall = 3
  pipefail = 4
  noexec = 5
  xtrace = 6
  verbose = 7
  noglob = 8
  noclobber = 9
  posix = 10
  vi = 11
  emacs = 12
  interactive = 13
  failglob = 14
  nullglob = 15
  inherit_errexit = 16
  strict_argv = 17
  strict_arith = 18
  strict_array = 19
  strict_control_flow = 20
  strict_echo = 21
  strict_errexit = 22
  strict_eval_builtin = 23
  strict_nameref = 24
  strict_word_eval = 25
  strict_backslash = 26
  strict_glob = 27
  simple_word_eval = 28
  dashglob = 29
  more_errexit = 30
  simple_test_builtin = 31
  parse_at = 32
  parse_brace = 33
  parse_index_expr = 34
  parse_paren = 35
  parse_rawc = 36
  parse_set = 37
  parse_equals = 38
  expand_aliases = 39
  extglob = 40
  lastpipe = 41
  progcomp = 42
  histappend = 43
  hostcomplete = 44
  cmdhist = 45
  assoc_expand_once = 46
  autocd = 47
  cdable_vars = 48
  cdspell = 49
  checkhash = 50
  checkjobs = 51
  checkwinsize = 52
  complete_fullquote = 53
  direxpand = 54
  dirspell = 55
  dotglob = 56
  execfail = 57
  extdebug = 58
  extquote = 59
  force_fignore = 60
  globasciiranges = 61
  globstar = 62
  gnu_errfmt = 63
  histreedit = 64
  histverify = 65
  huponexit = 66
  interactive_comments = 67
  lithist = 68
  localvar_inherit = 69
  localvar_unset = 70
  login_shell = 71
  mailwarn = 72
  no_empty_cmd_completion = 73
  nocaseglob = 74
  nocasematch = 75
  progcomp_alias = 76
  promptvars = 77
  restricted_shell = 78
  shift_verbose = 79
  sourcepath = 80
  xpg_echo = 81
  ARRAY_SIZE = 82

_option_str = {
  1: 'option.errexit',
  2: 'option.nounset',
  3: 'option.hashall',
  4: 'option.pipefail',
  5: 'option.noexec',
  6: 'option.xtrace',
  7: 'option.verbose',
  8: 'option.noglob',
  9: 'option.noclobber',
  10: 'option.posix',
  11: 'option.vi',
  12: 'option.emacs',
  13: 'option.interactive',
  14: 'option.failglob',
  15: 'option.nullglob',
  16: 'option.inherit_errexit',
  17: 'option.strict_argv',
  18: 'option.strict_arith',
  19: 'option.strict_array',
  20: 'option.strict_control_flow',
  21: 'option.strict_echo',
  22: 'option.strict_errexit',
  23: 'option.strict_eval_builtin',
  24: 'option.strict_nameref',
  25: 'option.strict_word_eval',
  26: 'option.strict_backslash',
  27: 'option.strict_glob',
  28: 'option.simple_word_eval',
  29: 'option.dashglob',
  30: 'option.more_errexit',
  31: 'option.simple_test_builtin',
  32: 'option.parse_at',
  33: 'option.parse_brace',
  34: 'option.parse_index_expr',
  35: 'option.parse_paren',
  36: 'option.parse_rawc',
  37: 'option.parse_set',
  38: 'option.parse_equals',
  39: 'option.expand_aliases',
  40: 'option.extglob',
  41: 'option.lastpipe',
  42: 'option.progcomp',
  43: 'option.histappend',
  44: 'option.hostcomplete',
  45: 'option.cmdhist',
  46: 'option.assoc_expand_once',
  47: 'option.autocd',
  48: 'option.cdable_vars',
  49: 'option.cdspell',
  50: 'option.checkhash',
  51: 'option.checkjobs',
  52: 'option.checkwinsize',
  53: 'option.complete_fullquote',
  54: 'option.direxpand',
  55: 'option.dirspell',
  56: 'option.dotglob',
  57: 'option.execfail',
  58: 'option.extdebug',
  59: 'option.extquote',
  60: 'option.force_fignore',
  61: 'option.globasciiranges',
  62: 'option.globstar',
  63: 'option.gnu_errfmt',
  64: 'option.histreedit',
  65: 'option.histverify',
  66: 'option.huponexit',
  67: 'option.interactive_comments',
  68: 'option.lithist',
  69: 'option.localvar_inherit',
  70: 'option.localvar_unset',
  71: 'option.login_shell',
  72: 'option.mailwarn',
  73: 'option.no_empty_cmd_completion',
  74: 'option.nocaseglob',
  75: 'option.nocasematch',
  76: 'option.progcomp_alias',
  77: 'option.promptvars',
  78: 'option.restricted_shell',
  79: 'option.shift_verbose',
  80: 'option.sourcepath',
  81: 'option.xpg_echo',
}

def option_str(val):
  # type: (option_t) -> str
  return _option_str[val]

builtin_t = int  # type alias for integer

class builtin_i(object):
  colon = 1
  dot = 2
  exec_ = 3
  eval = 4
  set = 5
  shift = 6
  times = 7
  trap = 8
  unset = 9
  builtin = 10
  readonly = 11
  local = 12
  declare = 13
  typeset = 14
  export_ = 15
  test = 16
  bracket = 17
  true_ = 18
  false_ = 19
  read = 20
  echo = 21
  printf = 22
  cd = 23
  pushd = 24
  popd = 25
  dirs = 26
  pwd = 27
  source = 28
  umask = 29
  wait = 30
  jobs = 31
  fg = 32
  bg = 33
  shopt = 34
  complete = 35
  compgen = 36
  compopt = 37
  compadjust = 38
  getopts = 39
  command = 40
  type = 41
  hash = 42
  help = 43
  history = 44
  alias = 45
  unalias = 46
  push = 47
  append = 48
  write = 49
  getline = 50
  json = 51
  repr = 52
  use = 53
  opts = 54
  ARRAY_SIZE = 55

_builtin_str = {
  1: 'builtin.colon',
  2: 'builtin.dot',
  3: 'builtin.exec_',
  4: 'builtin.eval',
  5: 'builtin.set',
  6: 'builtin.shift',
  7: 'builtin.times',
  8: 'builtin.trap',
  9: 'builtin.unset',
  10: 'builtin.builtin',
  11: 'builtin.readonly',
  12: 'builtin.local',
  13: 'builtin.declare',
  14: 'builtin.typeset',
  15: 'builtin.export_',
  16: 'builtin.test',
  17: 'builtin.bracket',
  18: 'builtin.true_',
  19: 'builtin.false_',
  20: 'builtin.read',
  21: 'builtin.echo',
  22: 'builtin.printf',
  23: 'builtin.cd',
  24: 'builtin.pushd',
  25: 'builtin.popd',
  26: 'builtin.dirs',
  27: 'builtin.pwd',
  28: 'builtin.source',
  29: 'builtin.umask',
  30: 'builtin.wait',
  31: 'builtin.jobs',
  32: 'builtin.fg',
  33: 'builtin.bg',
  34: 'builtin.shopt',
  35: 'builtin.complete',
  36: 'builtin.compgen',
  37: 'builtin.compopt',
  38: 'builtin.compadjust',
  39: 'builtin.getopts',
  40: 'builtin.command',
  41: 'builtin.type',
  42: 'builtin.hash',
  43: 'builtin.help',
  44: 'builtin.history',
  45: 'builtin.alias',
  46: 'builtin.unalias',
  47: 'builtin.push',
  48: 'builtin.append',
  49: 'builtin.write',
  50: 'builtin.getline',
  51: 'builtin.json',
  52: 'builtin.repr',
  53: 'builtin.use',
  54: 'builtin.opts',
}

def builtin_str(val):
  # type: (builtin_t) -> str
  return _builtin_str[val]

